<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
    <!-- Generated by javadoc -->
    <title>DataFormatter (POI API Documentation)</title>
    <link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
    <script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="DataFormatter (POI API Documentation)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":9,"i11":9,"i12":10};
var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";

</script>
<noscript>
    <div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.top.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/DataFormatter.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../org/apache/poi/ss/usermodel/DataFormat.html"
               title="interface in org.apache.poi.ss.usermodel"><span class="typeNameLink">Prev&nbsp;Class</span></a>
        </li>
        <li><a href="../../../../../org/apache/poi/ss/usermodel/DataValidation.html"
               title="interface in org.apache.poi.ss.usermodel"><span class="typeNameLink">Next&nbsp;Class</span></a>
        </li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/ss/usermodel/DataFormatter.html" target="_top">Frames</a>
        </li>
        <li><a href="DataFormatter.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_top">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.top">
        <!--   -->
    </a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
    <div class="subTitle">org.apache.poi.ss.usermodel</div>
    <h2 title="Class DataFormatter" class="title">Class DataFormatter</h2>
</div>
<div class="contentContainer">
    <ul class="inheritance">
        <li>java.lang.Object</li>
        <li>
            <ul class="inheritance">
                <li>org.apache.poi.ss.usermodel.DataFormatter</li>
            </ul>
        </li>
    </ul>
    <div class="description">
        <ul class="blockList">
            <li class="blockList">
                <dl>
                    <dt>All Implemented Interfaces:</dt>
                    <dd>java.util.Observer</dd>
                </dl>
                <dl>
                    <dt>Direct Known Subclasses:</dt>
                    <dd><a href="../../../../../org/apache/poi/hssf/usermodel/HSSFDataFormatter.html"
                           title="class in org.apache.poi.hssf.usermodel">HSSFDataFormatter</a></dd>
                </dl>
                <hr>
                <br>
                <pre>public class <span class="typeNameLabel">DataFormatter</span>
extends java.lang.Object
implements java.util.Observer</pre>
                <div class="block">DataFormatter contains methods for formatting the value stored in an
                    Cell. This can be useful for reports and GUI presentations when you
                    need to display data exactly as it appears in Excel. Supported formats
                    include currency, SSN, percentages, decimals, dates, phone numbers, zip
                    codes, etc.
                    <p>
                        Internally, formats will be implemented using subclasses of <code>Format</code>
                        such as <code>DecimalFormat</code> and <code>SimpleDateFormat</code>. Therefore the
                        formats used by this class must obey the same pattern rules as these Format
                        subclasses. This means that only legal number pattern characters ("0", "#",
                        ".", "," etc.) may appear in number formats. Other characters can be
                        inserted <em>before</em> or <em> after</em> the number pattern to form a
                        prefix or suffix.
                    </p>
                    <p>
                        For example the Excel pattern <code>"$#,##0.00 "USD"_);($#,##0.00 "USD")"
                    </code> will be correctly formatted as "$1,000.00 USD" or "($1,000.00 USD)".
                        However the pattern <code>"00-00-00"</code> is incorrectly formatted by
                        DecimalFormat as "000000--". For Excel formats that are not compatible with
                        DecimalFormat, you can provide your own custom <code>Format</code> implementation
                        via <code>DataFormatter.addFormat(String,Format)</code>. The following
                        custom formats are already provided by this class:
                    </p>
                    <pre>
 <ul><li>SSN "000-00-0000"</li>
     <li>Phone Number "(###) ###-####"</li>
     <li>Zip plus 4 "00000-0000"</li>
 </ul>
 </pre>
                    <p>
                        If the Excel format pattern cannot be parsed successfully, then a default
                        format will be used. The default number format will mimic the Excel General
                        format: "#" for whole numbers and "#.##########" for decimal numbers. You
                        can override the default format pattern with <code>
                        DataFormatter.setDefaultNumberFormat(Format)</code>. <b>Note:</b> the
                        default format will only be used when a Format cannot be created from the
                        cell's data format string.

                    <p>
                        Note that by default formatted numeric values are trimmed.
                        Excel formats can contain spacers and padding and the default behavior is to strip them off.
                    </p>
                    <p>Example:</p>
                    <p>
                        Consider a numeric cell with a value <code>12.343</code> and format <code>"##.##_ "</code>.
                        The trailing underscore and space ("_ ") in the format adds a space to the end and Excel formats
                        this cell as <code>"12.34 "</code>,
                        but <code>DataFormatter</code> trims the formatted value and returns <code>"12.34"</code>.
                    </p>
                    You can enable spaces by passing the <code>emulateCSV=true</code> flag in the
                    <code>DateFormatter</code> cosntructor.
                    If set to true, then the output tries to conform to what you get when you take an xls or xlsx in
                    Excel and Save As CSV file:
                    <ul>
                        <li>returned values are not trimmed</li>
                        <li>Invalid dates are formatted as 255 pound signs ("#")</li>
                        <li>simulate Excel's handling of a format string of all # when the value is 0.
                            Excel will output "", <code>DataFormatter</code> will output "0".
                    </ul>
                    <p>
                        Some formats are automatically "localized" by Excel, eg show as mm/dd/yyyy when
                        loaded in Excel in some Locales but as dd/mm/yyyy in others. These are always
                        returned in the "default" (US) format, as stored in the file.
                        Some format strings request an alternate locale, eg
                        <code>[$-809]d/m/yy h:mm AM/PM</code> which explicitly requests UK locale.
                        These locale directives are (currently) ignored.
                        You can use <a href="../../../../../org/apache/poi/ss/util/DateFormatConverter.html"
                                       title="class in org.apache.poi.ss.util"><code>DateFormatConverter</code></a> to
                        do some of this localisation if
                        you need it.</div>
            </li>
        </ul>
    </div>
    <div class="summary">
        <ul class="blockList">
            <li class="blockList">
                <!-- ======== CONSTRUCTOR SUMMARY ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.summary">
                        <!--   -->
                    </a>
                        <h3>Constructor Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Constructor Summary table, listing constructors, and an explanation">
                            <caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
                            <tr>
                                <th class="colOne" scope="col">Constructor and Description</th>
                            </tr>
                            <tr class="altColor">
                                <td class="colOne"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/usermodel/DataFormatter.html#DataFormatter--">DataFormatter</a></span>()</code>
                                    <div class="block">Creates a formatter using the <code>default locale</code>.</div>
                                </td>
                            </tr>
                            <tr class="rowColor">
                                <td class="colOne"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/usermodel/DataFormatter.html#DataFormatter-boolean-">DataFormatter</a></span>(boolean&nbsp;emulateCSV)</code>
                                    <div class="block">Creates a formatter using the <code>default locale</code>.</div>
                                </td>
                            </tr>
                            <tr class="altColor">
                                <td class="colOne"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/usermodel/DataFormatter.html#DataFormatter-java.util.Locale-">DataFormatter</a></span>(java.util.Locale&nbsp;locale)</code>
                                    <div class="block">Creates a formatter using the given locale.</div>
                                </td>
                            </tr>
                            <tr class="rowColor">
                                <td class="colOne"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/usermodel/DataFormatter.html#DataFormatter-java.util.Locale-boolean-">DataFormatter</a></span>(java.util.Locale&nbsp;locale,
                                    boolean&nbsp;emulateCSV)</code>
                                    <div class="block">Creates a formatter using the given locale.</div>
                                </td>
                            </tr>
                            <tr class="altColor">
                                <td class="colOne"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/usermodel/DataFormatter.html#DataFormatter-java.util.Locale-boolean-boolean-">DataFormatter</a></span>(java.util.Locale&nbsp;locale,
                                    boolean&nbsp;localeIsAdapting,
                                    boolean&nbsp;emulateCSV)</code>
                                    <div class="block">Creates a formatter using the given locale.</div>
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>
                <!-- ========== METHOD SUMMARY =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.summary">
                        <!--   -->
                    </a>
                        <h3>Method Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Method Summary table, listing methods, and an explanation">
                            <caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span
                                    id="t1" class="tableTab"><span><a
                                    href="javascript:show(1);">Static Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a
                                    href="javascript:show(2);">Instance Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a
                                    href="javascript:show(8);">Concrete Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Method and Description</th>
                            </tr>
                            <tr id="i0" class="altColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/usermodel/DataFormatter.html#addFormat-java.lang.String-java.text.Format-">addFormat</a></span>(java.lang.String&nbsp;excelFormatStr,
                                    java.text.Format&nbsp;format)</code>
                                    <div class="block">Adds a new format to the available formats.</div>
                                </td>
                            </tr>
                            <tr id="i1" class="rowColor">
                                <td class="colFirst"><code>java.text.Format</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/usermodel/DataFormatter.html#createFormat-org.apache.poi.ss.usermodel.Cell-">createFormat</a></span>(<a
                                        href="../../../../../org/apache/poi/ss/usermodel/Cell.html"
                                        title="interface in org.apache.poi.ss.usermodel">Cell</a>&nbsp;cell)</code>
                                    <div class="block">Create and return a Format based on the format string from a
                                        cell's
                                        style.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i2" class="altColor">
                                <td class="colFirst"><code>java.lang.String</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/usermodel/DataFormatter.html#formatCellValue-org.apache.poi.ss.usermodel.Cell-">formatCellValue</a></span>(<a
                                        href="../../../../../org/apache/poi/ss/usermodel/Cell.html"
                                        title="interface in org.apache.poi.ss.usermodel">Cell</a>&nbsp;cell)</code>
                                    <div class="block">
                                        Returns the formatted value of a cell as a <tt>String</tt> regardless
                                        of the cell type.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i3" class="rowColor">
                                <td class="colFirst"><code>java.lang.String</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/usermodel/DataFormatter.html#formatCellValue-org.apache.poi.ss.usermodel.Cell-org.apache.poi.ss.usermodel.FormulaEvaluator-">formatCellValue</a></span>(<a
                                        href="../../../../../org/apache/poi/ss/usermodel/Cell.html"
                                        title="interface in org.apache.poi.ss.usermodel">Cell</a>&nbsp;cell,
                                    <a href="../../../../../org/apache/poi/ss/usermodel/FormulaEvaluator.html"
                                       title="interface in org.apache.poi.ss.usermodel">FormulaEvaluator</a>&nbsp;evaluator)</code>
                                    <div class="block">
                                        Returns the formatted value of a cell as a <tt>String</tt> regardless
                                        of the cell type.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i4" class="altColor">
                                <td class="colFirst"><code>java.lang.String</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/usermodel/DataFormatter.html#formatCellValue-org.apache.poi.ss.usermodel.Cell-org.apache.poi.ss.usermodel.FormulaEvaluator-org.apache.poi.ss.formula.ConditionalFormattingEvaluator-">formatCellValue</a></span>(<a
                                        href="../../../../../org/apache/poi/ss/usermodel/Cell.html"
                                        title="interface in org.apache.poi.ss.usermodel">Cell</a>&nbsp;cell,
                                    <a href="../../../../../org/apache/poi/ss/usermodel/FormulaEvaluator.html"
                                       title="interface in org.apache.poi.ss.usermodel">FormulaEvaluator</a>&nbsp;evaluator,
                                    <a href="../../../../../org/apache/poi/ss/formula/ConditionalFormattingEvaluator.html"
                                       title="class in org.apache.poi.ss.formula">ConditionalFormattingEvaluator</a>&nbsp;cfEvaluator)</code>
                                    <div class="block">
                                        Returns the formatted value of a cell as a <tt>String</tt> regardless
                                        of the cell type.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i5" class="rowColor">
                                <td class="colFirst"><code>java.lang.String</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/usermodel/DataFormatter.html#formatRawCellContents-double-int-java.lang.String-">formatRawCellContents</a></span>(double&nbsp;value,
                                    int&nbsp;formatIndex,
                                    java.lang.String&nbsp;formatString)</code>
                                    <div class="block">Formats the given raw cell value, based on the supplied
                                        format index and string, according to excel style rules.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i6" class="altColor">
                                <td class="colFirst"><code>java.lang.String</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/usermodel/DataFormatter.html#formatRawCellContents-double-int-java.lang.String-boolean-">formatRawCellContents</a></span>(double&nbsp;value,
                                    int&nbsp;formatIndex,
                                    java.lang.String&nbsp;formatString,
                                    boolean&nbsp;use1904Windowing)</code>
                                    <div class="block">Formats the given raw cell value, based on the supplied
                                        format index and string, according to excel style rules.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i7" class="rowColor">
                                <td class="colFirst"><code>java.text.Format</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/usermodel/DataFormatter.html#getDefaultFormat-org.apache.poi.ss.usermodel.Cell-">getDefaultFormat</a></span>(<a
                                        href="../../../../../org/apache/poi/ss/usermodel/Cell.html"
                                        title="interface in org.apache.poi.ss.usermodel">Cell</a>&nbsp;cell)</code>
                                    <div class="block">Returns a default format for a cell.</div>
                                </td>
                            </tr>
                            <tr id="i8" class="altColor">
                                <td class="colFirst"><code>java.util.Observable</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/usermodel/DataFormatter.html#getLocaleChangedObservable--">getLocaleChangedObservable</a></span>()</code>
                                    <div class="block">If the Locale has been changed via <a
                                            href="../../../../../org/apache/poi/util/LocaleUtil.html#setUserLocale-java.util.Locale-"><code>LocaleUtil.setUserLocale(Locale)</code></a>
                                        the stored
                                        formats need to be refreshed.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i9" class="rowColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/usermodel/DataFormatter.html#setDefaultNumberFormat-java.text.Format-">setDefaultNumberFormat</a></span>(java.text.Format&nbsp;format)</code>
                                    <div class="block">
                                        Sets a default number format to be used when the Excel format cannot be
                                        parsed successfully.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i10" class="altColor">
                                <td class="colFirst"><code>static void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/usermodel/DataFormatter.html#setExcelStyleRoundingMode-java.text.DecimalFormat-">setExcelStyleRoundingMode</a></span>(java.text.DecimalFormat&nbsp;format)</code>
                                    <div class="block">Enables excel style rounding mode (round half up) on the
                                        Decimal Format given.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i11" class="rowColor">
                                <td class="colFirst"><code>static void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/usermodel/DataFormatter.html#setExcelStyleRoundingMode-java.text.DecimalFormat-java.math.RoundingMode-">setExcelStyleRoundingMode</a></span>(java.text.DecimalFormat&nbsp;format,
                                    java.math.RoundingMode&nbsp;roundingMode)</code>
                                    <div class="block">Enables custom rounding mode on the given Decimal Format.</div>
                                </td>
                            </tr>
                            <tr id="i12" class="altColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/ss/usermodel/DataFormatter.html#update-java.util.Observable-java.lang.Object-">update</a></span>(java.util.Observable&nbsp;observable,
                                    java.lang.Object&nbsp;localeObj)</code>
                                    <div class="block">Update formats when locale has been changed</div>
                                </td>
                            </tr>
                        </table>
                        <ul class="blockList">
                            <li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
                                <!--   -->
                            </a>
                                <h3>Methods inherited from class&nbsp;java.lang.Object</h3>
                                <code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait,
                                    wait, wait</code></li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
    <div class="details">
        <ul class="blockList">
            <li class="blockList">
                <!-- ========= CONSTRUCTOR DETAIL ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.detail">
                        <!--   -->
                    </a>
                        <h3>Constructor Detail</h3>
                        <a name="DataFormatter--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>DataFormatter</h4>
                                <pre>public&nbsp;DataFormatter()</pre>
                                <div class="block">Creates a formatter using the <code>default locale</code>.</div>
                            </li>
                        </ul>
                        <a name="DataFormatter-boolean-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>DataFormatter</h4>
                                <pre>public&nbsp;DataFormatter(boolean&nbsp;emulateCSV)</pre>
                                <div class="block">Creates a formatter using the <code>default locale</code>.</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>emulateCSV</code> - whether to emulate CSV output.</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="DataFormatter-java.util.Locale-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>DataFormatter</h4>
                                <pre>public&nbsp;DataFormatter(java.util.Locale&nbsp;locale)</pre>
                                <div class="block">Creates a formatter using the given locale.</div>
                            </li>
                        </ul>
                        <a name="DataFormatter-java.util.Locale-boolean-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>DataFormatter</h4>
                                <pre>public&nbsp;DataFormatter(java.util.Locale&nbsp;locale,
                     boolean&nbsp;emulateCSV)</pre>
                                <div class="block">Creates a formatter using the given locale.</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>emulateCSV</code> - whether to emulate CSV output.</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="DataFormatter-java.util.Locale-boolean-boolean-">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>DataFormatter</h4>
                                <pre>public&nbsp;DataFormatter(java.util.Locale&nbsp;locale,
                     boolean&nbsp;localeIsAdapting,
                     boolean&nbsp;emulateCSV)</pre>
                                <div class="block">Creates a formatter using the given locale.</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>localeIsAdapting</code> - (true only if locale is not user-specified)</dd>
                                    <dd><code>emulateCSV</code> - whether to emulate CSV output.</dd>
                                </dl>
                            </li>
                        </ul>
                    </li>
                </ul>
                <!-- ============ METHOD DETAIL ========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.detail">
                        <!--   -->
                    </a>
                        <h3>Method Detail</h3>
                        <a name="createFormat-org.apache.poi.ss.usermodel.Cell-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>createFormat</h4>
                                <pre>public&nbsp;java.text.Format&nbsp;createFormat(<a
                                        href="../../../../../org/apache/poi/ss/usermodel/Cell.html"
                                        title="interface in org.apache.poi.ss.usermodel">Cell</a>&nbsp;cell)</pre>
                                <div class="block">Create and return a Format based on the format string from a cell's
                                    style. If the pattern cannot be parsed, return a default pattern.
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>cell</code> - The Excel cell</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>A Format representing the excel format. May return null.</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getDefaultFormat-org.apache.poi.ss.usermodel.Cell-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getDefaultFormat</h4>
                                <pre>public&nbsp;java.text.Format&nbsp;getDefaultFormat(<a
                                        href="../../../../../org/apache/poi/ss/usermodel/Cell.html"
                                        title="interface in org.apache.poi.ss.usermodel">Cell</a>&nbsp;cell)</pre>
                                <div class="block">Returns a default format for a cell.</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>cell</code> - The cell</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>a default format</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="formatRawCellContents-double-int-java.lang.String-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>formatRawCellContents</h4>
                                <pre>public&nbsp;java.lang.String&nbsp;formatRawCellContents(double&nbsp;value,
                                              int&nbsp;formatIndex,
                                              java.lang.String&nbsp;formatString)</pre>
                                <div class="block">Formats the given raw cell value, based on the supplied
                                    format index and string, according to excel style rules.
                                </div>
                                <dl>
                                    <dt><span class="seeLabel">See Also:</span></dt>
                                    <dd>
                                        <a href="../../../../../org/apache/poi/ss/usermodel/DataFormatter.html#formatCellValue-org.apache.poi.ss.usermodel.Cell-"><code>formatCellValue(Cell)</code></a>
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="formatRawCellContents-double-int-java.lang.String-boolean-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>formatRawCellContents</h4>
                                <pre>public&nbsp;java.lang.String&nbsp;formatRawCellContents(double&nbsp;value,
                                              int&nbsp;formatIndex,
                                              java.lang.String&nbsp;formatString,
                                              boolean&nbsp;use1904Windowing)</pre>
                                <div class="block">Formats the given raw cell value, based on the supplied
                                    format index and string, according to excel style rules.
                                </div>
                                <dl>
                                    <dt><span class="seeLabel">See Also:</span></dt>
                                    <dd>
                                        <a href="../../../../../org/apache/poi/ss/usermodel/DataFormatter.html#formatCellValue-org.apache.poi.ss.usermodel.Cell-"><code>formatCellValue(Cell)</code></a>
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="formatCellValue-org.apache.poi.ss.usermodel.Cell-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>formatCellValue</h4>
                                <pre>public&nbsp;java.lang.String&nbsp;formatCellValue(<a
                                        href="../../../../../org/apache/poi/ss/usermodel/Cell.html"
                                        title="interface in org.apache.poi.ss.usermodel">Cell</a>&nbsp;cell)</pre>
                                <div class="block"><p>
                                    Returns the formatted value of a cell as a <tt>String</tt> regardless
                                    of the cell type. If the Excel format pattern cannot be parsed then the
                                    cell value will be formatted using a default format.
                                </p>
                                    <p>When passed a null or blank cell, this method will return an empty
                                        String (""). Formulas in formula type cells will not be evaluated.
                                    </p></div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>cell</code> - The cell</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the formatted cell value as a String</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="formatCellValue-org.apache.poi.ss.usermodel.Cell-org.apache.poi.ss.usermodel.FormulaEvaluator-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>formatCellValue</h4>
                                <pre>public&nbsp;java.lang.String&nbsp;formatCellValue(<a
                                        href="../../../../../org/apache/poi/ss/usermodel/Cell.html"
                                        title="interface in org.apache.poi.ss.usermodel">Cell</a>&nbsp;cell,
                                        <a href="../../../../../org/apache/poi/ss/usermodel/FormulaEvaluator.html"
                                           title="interface in org.apache.poi.ss.usermodel">FormulaEvaluator</a>&nbsp;evaluator)</pre>
                                <div class="block"><p>
                                    Returns the formatted value of a cell as a <tt>String</tt> regardless
                                    of the cell type. If the Excel number format pattern cannot be parsed then the
                                    cell value will be formatted using a default format.
                                </p>
                                    <p>When passed a null or blank cell, this method will return an empty
                                        String (""). Formula cells will be evaluated using the given
                                        <a href="../../../../../org/apache/poi/ss/usermodel/FormulaEvaluator.html"
                                           title="interface in org.apache.poi.ss.usermodel"><code>FormulaEvaluator</code></a>
                                        if the evaluator is non-null. If the
                                        evaluator is null, then the formula String will be returned. The caller
                                        is responsible for setting the currentRow on the evaluator
                                    </p></div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>cell</code> - The cell (can be null)</dd>
                                    <dd><code>evaluator</code> - The FormulaEvaluator (can be null)</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>a string value of the cell</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="formatCellValue-org.apache.poi.ss.usermodel.Cell-org.apache.poi.ss.usermodel.FormulaEvaluator-org.apache.poi.ss.formula.ConditionalFormattingEvaluator-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>formatCellValue</h4>
                                <pre>public&nbsp;java.lang.String&nbsp;formatCellValue(<a
                                        href="../../../../../org/apache/poi/ss/usermodel/Cell.html"
                                        title="interface in org.apache.poi.ss.usermodel">Cell</a>&nbsp;cell,
                                        <a href="../../../../../org/apache/poi/ss/usermodel/FormulaEvaluator.html"
                                           title="interface in org.apache.poi.ss.usermodel">FormulaEvaluator</a>&nbsp;evaluator,
                                        <a href="../../../../../org/apache/poi/ss/formula/ConditionalFormattingEvaluator.html"
                                           title="class in org.apache.poi.ss.formula">ConditionalFormattingEvaluator</a>&nbsp;cfEvaluator)</pre>
                                <div class="block"><p>
                                    Returns the formatted value of a cell as a <tt>String</tt> regardless
                                    of the cell type. If the Excel number format pattern cannot be parsed then the
                                    cell value will be formatted using a default format.
                                </p>
                                    <p>When passed a null or blank cell, this method will return an empty
                                        String (""). Formula cells will be evaluated using the given
                                        <a href="../../../../../org/apache/poi/ss/usermodel/FormulaEvaluator.html"
                                           title="interface in org.apache.poi.ss.usermodel"><code>FormulaEvaluator</code></a>
                                        if the evaluator is non-null. If the
                                        evaluator is null, then the formula String will be returned. The caller
                                        is responsible for setting the currentRow on the evaluator
                                    </p>
                                    <p>
                                        When a ConditionalFormattingEvaluator is present, it is checked first to see
                                        if there is a number format to apply. If multiple rules apply, the last one is
                                        used.
                                        If no ConditionalFormattingEvaluator is present, no rules apply, or the applied
                                        rules do not define a format, the cell's style format is used.
                                    </p>
                                    <p>
                                        The two evaluators should be from the same context, to avoid inconsistencies in
                                        cached values.
                                    </p></div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>cell</code> - The cell (can be null)</dd>
                                    <dd><code>evaluator</code> - The FormulaEvaluator (can be null)</dd>
                                    <dd><code>cfEvaluator</code> - ConditionalFormattingEvaluator (can be null)</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>a string value of the cell</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="setDefaultNumberFormat-java.text.Format-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setDefaultNumberFormat</h4>
                                <pre>public&nbsp;void&nbsp;setDefaultNumberFormat(java.text.Format&nbsp;format)</pre>
                                <div class="block"><p>
                                    Sets a default number format to be used when the Excel format cannot be
                                    parsed successfully. <b>Note:</b> This is a fall back for when an error
                                    occurs while parsing an Excel number format pattern. This will not
                                    affect cells with the <em>General</em> format.
                                </p>
                                    <p>
                                        The value that will be passed to the Format's format method (specified
                                        by <code>java.text.Format#format</code>) will be a double value from a
                                        numeric cell. Therefore the code in the format method should expect a
                                        <code>Number</code> value.
                                    </p></div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>format</code> - A Format instance to be used as a default</dd>
                                    <dt><span class="seeLabel">See Also:</span></dt>
                                    <dd><code>Format.format(java.lang.Object)</code></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="addFormat-java.lang.String-java.text.Format-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>addFormat</h4>
                                <pre>public&nbsp;void&nbsp;addFormat(java.lang.String&nbsp;excelFormatStr,
                      java.text.Format&nbsp;format)</pre>
                                <div class="block">Adds a new format to the available formats.
                                    <p>
                                        The value that will be passed to the Format's format method (specified
                                        by <code>java.text.Format#format</code>) will be a double value from a
                                        numeric cell. Therefore the code in the format method should expect a
                                        <code>Number</code> value.
                                    </p></div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>excelFormatStr</code> - The data format string</dd>
                                    <dd><code>format</code> - A Format instance</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="setExcelStyleRoundingMode-java.text.DecimalFormat-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setExcelStyleRoundingMode</h4>
                                <pre>public static&nbsp;void&nbsp;setExcelStyleRoundingMode(java.text.DecimalFormat&nbsp;format)</pre>
                                <div class="block">Enables excel style rounding mode (round half up) on the
                                    Decimal Format given.
                                </div>
                            </li>
                        </ul>
                        <a name="setExcelStyleRoundingMode-java.text.DecimalFormat-java.math.RoundingMode-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setExcelStyleRoundingMode</h4>
                                <pre>public static&nbsp;void&nbsp;setExcelStyleRoundingMode(java.text.DecimalFormat&nbsp;format,
                                             java.math.RoundingMode&nbsp;roundingMode)</pre>
                                <div class="block">Enables custom rounding mode on the given Decimal Format.</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>format</code> - DecimalFormat</dd>
                                    <dd><code>roundingMode</code> - RoundingMode</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getLocaleChangedObservable--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getLocaleChangedObservable</h4>
                                <pre>public&nbsp;java.util.Observable&nbsp;getLocaleChangedObservable()</pre>
                                <div class="block">If the Locale has been changed via <a
                                        href="../../../../../org/apache/poi/util/LocaleUtil.html#setUserLocale-java.util.Locale-"><code>LocaleUtil.setUserLocale(Locale)</code></a>
                                    the stored
                                    formats need to be refreshed. All formats which aren't originated from DataFormatter
                                    itself, i.e. all Formats added via <a
                                            href="../../../../../org/apache/poi/ss/usermodel/DataFormatter.html#addFormat-java.lang.String-java.text.Format-"><code>addFormat(String,
                                        Format)</code></a> and
                                    <a href="../../../../../org/apache/poi/ss/usermodel/DataFormatter.html#setDefaultNumberFormat-java.text.Format-"><code>setDefaultNumberFormat(Format)</code></a>,
                                    need to be added again.
                                    To notify callers, the returned <code>Observable</code> should be used.
                                    The Object in <code>Observer.update(Observable, Object)</code> is the new Locale.
                                </div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the listener object, where callers can register themselves</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="update-java.util.Observable-java.lang.Object-">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>update</h4>
                                <pre>public&nbsp;void&nbsp;update(java.util.Observable&nbsp;observable,
                   java.lang.Object&nbsp;localeObj)</pre>
                                <div class="block">Update formats when locale has been changed</div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code>update</code>&nbsp;in interface&nbsp;<code>java.util.Observer</code></dd>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>observable</code> - usually this is our own Observable instance</dd>
                                    <dd><code>localeObj</code> - only reacts on Locale objects</dd>
                                </dl>
                            </li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.bottom.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/DataFormatter.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../org/apache/poi/ss/usermodel/DataFormat.html"
               title="interface in org.apache.poi.ss.usermodel"><span class="typeNameLink">Prev&nbsp;Class</span></a>
        </li>
        <li><a href="../../../../../org/apache/poi/ss/usermodel/DataValidation.html"
               title="interface in org.apache.poi.ss.usermodel"><span class="typeNameLink">Next&nbsp;Class</span></a>
        </li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/ss/usermodel/DataFormatter.html" target="_top">Frames</a>
        </li>
        <li><a href="DataFormatter.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_bottom">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.bottom">
        <!--   -->
    </a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy">
    <small>
        <i>Copyright 2018 The Apache Software Foundation or
            its licensors, as applicable.</i>
    </small>
</p>
</body>
</html>
